﻿using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.ultraDataSource1;

            this.ultraDataSource1.Band.Columns.Add("Col0", typeof(string));
            this.ultraDataSource1.Band.Columns.Add("Col1", typeof(int));

            var rowsCount = 10;
            this.ultraDataSource1.Rows.SetCount(rowsCount);

            UltraDataRow row;

            for (int i = 0; i < rowsCount; i++)
            {
                row = this.ultraDataSource1.Rows[i];
                row["Col0"] = i % 2 == 0 ? "Category 1" : "Category 2";
                row["Col1"] = i % 3 == 0 ? 100 : 200 ;
            }

            UltraGridBand band = this.ultraGrid1.DisplayLayout.Bands[0];

            band.Columns[1].Width = 200;

            this.ultraGrid1.DisplayLayout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            band.SortedColumns.Add("Col0", false, true);
            band.SortedColumns.Add("Col1", false, false);
            band.Columns[1].MergedCellStyle = MergedCellStyle.Always;

            //var summary = this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(SummaryType.Sum, this.ultraGrid1.DisplayLayout.Bands[0].Columns["Col1"]);

            SummarySettings summaryCustom = band.Summaries.Add(
                "CustomSum",
                SummaryType.Custom,
                new MergedCellsSumSummary(),
                band.Columns["Col1"],
                SummaryPosition.UseSummaryPositionColumn,
                band.Columns["Col1"]
                );

            summaryCustom.DisplayFormat = "Megred cells sum = {0}";
        }
    }
}
