﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WindowsFormsApp1
{
    public class MergedCellsSumSummary : ICustomSummaryCalculator
    {
        HashSet<int> helperSet;
        public void AggregateCustomSummary(SummarySettings summarySettings, UltraGridRow row)
        {
            object curValue = row.GetCellValue(summarySettings.SourceColumn);

            if (curValue is DBNull)
            {
                return;
            }

            var currentNumber = Int32.Parse(curValue.ToString());
            if (!this.helperSet.Contains(currentNumber))
            {
                this.helperSet.Add(currentNumber);
            }
        }

        public void BeginCustomSummary(SummarySettings summarySettings, RowsCollection rows)
        {
            this.helperSet = new HashSet<int>();
        }

        public object EndCustomSummary(SummarySettings summarySettings, RowsCollection rows)
        {
            return this.helperSet.Sum();
        }
    }
}
